%FreakLab - FreakLab_opt4.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Dieses Skript steuert das Bedienfeld 4 - Farbabbildung.
%
%Theorie:
%
%In den Skripten FreakLab_opt2.m bis FreakLab_opt3.m ging es um Geometrische
%Transformationen der Bilder. Dabei wurden den einzelnen Pixeln komplexe
%Zahlen oder Vektoren zugeordnet. Da auch die Farben des Bildes durch 
%Zahlentripel an jedem Pixel reprsentiert werden, knnen auch diese
%einer Transformation unterzogen werden, was in diesem Fall auf
%interessante Farbeffekte fhrt.
%
%Die Logik ist also [Farbwert an einem Pixel nachher] =
%f_beliebig([Farbwert an einem Pixel vorher])
%
%Dazu gibt es gleich wie in FreakLab_opt3.m Zeilen fr die Eingabe einer
%Formel, ein Drop-Down-Men zur Auswahl der Zeile und Buttons zum Lschen
%oder Hinzufgen von Zeilen sowie einen Formelbaukasten. Allerdings treten
%3 unterschiedliche Formeln auf, da fr jeden Farbkanal (Rot, Grn oder
%Blau) eine eigene Formel festlegbar sein soll. Durch das popupmenu4 wird
%der Farbkanal ausgewhlt.
%
%Desweiteren ist es interessant die Farbkanle zu vertauschen. Das 
%geschieht mit beim Klick auf das popupmenu5. Bei drei Farbkanlen gibt es
%6 Vertauschungspermutationen, dementsprechend verfgt das Men ber 6
%Eintrge.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

%Diese Funktion bewirkt, dass das alle anderen Funktionen in diesem Skript 
%von aussen aufgerufen werden knnen in der Form: FreakLab_opt4('Funkname')
function varargout = FreakLab_opt4(varargin)

    func = str2func(varargin{1});
    
    if(nargout)
        
        [varargout{1:nargout}] = func(varargin{2:end});
        
    else
        
        func(varargin{2:end});
        
    end
    
end

%Aktion bei Auswahl eines Farbkanals
function popupmenu4_Callback(hObject, eventdata, handles)

    %Auf erste Formelzeile des zuvor ausgewhlten Farbkanals
    %zurckschalten, da bei neuerlicher Anzeige wie bei allen
    %'Refreshments' immer die erste Zeile angezeigt wird
    handles.holtrac(handles.holtrarow) = 1;
    
    %Nummer des Farbkanals
    val = get(hObject,'Value');
    
    %Zustndige Farbkanalvariable belegen
    handles.holtrarow = val;
    
    %Gewinnen und Setzen des Strings von popupmenu6: lautet Zeile1, Zeile2,
    %... bis zur Gesamtanzahl an Zeilen der Formel fr diesen Farbkanal
    stri = handles.zeile(1:handles.trafos(handles.holtrarow));
    set(handles.popupmenu6,'String',stri,'Value',1);
    
    %Abrufen des Formelstrings der Zeile 1 fr diesen Kanal
    stri = handles.holtra(1,handles.holtrarow);
    stri = cell2struct(stri,{'stri'},1);
    stri = stri.stri;
    
    %Anzeigen des Zeilenstrings
    set(handles.edit21,'String',stri);
    
    %Auf erste Formelzeile des aktuell ausgewhlten Farbkanals schalten
    set(handles.popupmenu6,'Value',1);
    
    %Bedienfeld auffrischen
    disenable(hObject,handles,'on',4);

    guidata(hObject,handles);

end

%Aktion bei Auswahl einer Farbkanalvertauschung
function popupmenu5_Callback(hObject, eventdata, handles)

    val = get(hObject,'Value');
    
    %Auswahl der hinter dieser Vertauschung stehenden Indexreihenfolge
    handles.colshift = [1,2,3;1,3,2;2,1,3;2,3,1;3,1,2;3,2,1];
    handles.colshift = handles.colshift(val,:);
     
    %Darstellung mit vernderter Indexreihenfolge
    disp_4_1(hObject,handles);

    guidata(hObject,handles);

end

%Aktion beim Klicken auf den Formelbausatz fr aktuellen Farbkanal
function popupmenu7_Callback(hObject, eventdata, handles)

    val = get(hObject,'Value');
    
    stri = get(hObject,'String');
    stri = stri(val);
    stri = cell2struct(stri,{'stri'},1);
    stri = [' ',stri.stri,'(x) '];
    
    if(val == 1)
        
        stri = ' + ';
        
    elseif(val == 2)
        
        stri = ' - ';
        
    elseif(val == 3)
        
        stri = ' * ';
        
    elseif(val == 4)
        
        stri = ' / ';
        
    elseif(val == 5)
        
        stri = ' ^ ';
        
    end
    
    formel = get(handles.edit21,'String');
    
    if(~press(handles.edit21,handles))
        
        set(handles.edit21,'String',[formel,stri]);
        handles.holtra(handles.holtrac(handles.holtrarow),handles.holtrarow) = {[formel,stri]};
        
    end
    
    uicontrol(handles.edit21);
    
    disp_4_1(hObject,handles);
    
    guidata(hObject,handles);

end

%Aktion bei Eingabe einer Formel in das Formelzeilen-Textfeld fr
%aktuellen Farbkanal
%Man beachte: Das Edit-Textfelder 21 wurden unter init mit der
%KeyPressFcn press versehen. Diese bewirkt die oben erwhnte
%Sicherung gegen 'zu lang werden' (siehe press.m)
function edit21_Callback(hObject, eventdata, handles)

    inp = get(hObject,'String');
    
    handles.holtra(handles.holtrac(handles.holtrarow),handles.holtrarow) = {inp};
    
    disp_4_1(hObject,handles);
    
    guidata(hObject,handles);

end

%Aktion bei Auswahl der aktuell angezeigten Zeile fr aktuellen Farbkanal
function popupmenu6_Callback(hObject, eventdata, handles)

    handles.holtrac(handles.holtrarow) = get(hObject,'Value');
    
    stri2 = handles.holtra(handles.holtrac(handles.holtrarow),handles.holtrarow);
    stri2 = cell2struct(stri2,{'stri2'},1);
    stri2 = stri2.stri2;
    
    set(handles.edit21,'String',stri2);
    
    guidata(hObject,handles);

end

%Aktion beim Hinzufgen einer weiteren Zeile fr aktuellen Farbkanal
function pushbutton11_Callback(hObject, eventdata, handles)

    set(handles.pushbutton12,'Enable','on');

    handles.trafos(handles.holtrarow) = handles.trafos(handles.holtrarow) + 1;

    stri = get(handles.popupmenu6,'String');
    stri = [stri;['Zeile ',num2str(handles.trafos(handles.holtrarow))]];

    set(handles.popupmenu6,'String',stri);
        
    if(handles.trafos(handles.holtrarow) == 9)
        
        set(hObject,'Enable','off');
        
    end
    
    guidata(hObject,handles);

end

%Aktion beim Entfernen der letzten Zeile fr aktuellen Farbkanal
function pushbutton12_Callback(hObject, eventdata, handles)

    set(handles.pushbutton11,'Enable','on');
    
    stri = get(handles.popupmenu6,'String');
    
    handles.holtrac(handles.holtrarow) = 1;
    
    set(handles.popupmenu6,'Value',1);
    
    stri2 = handles.holtra(handles.holtrac(handles.holtrarow),handles.holtrarow);
    stri2 = cell2struct(stri2,{'stri2'},1);
    stri2 = stri2.stri2;
    
    set(handles.edit21,'String',stri2);

    if(handles.trafos(handles.holtrarow) >= 2)
        
        stri = stri(1:(end-1),:);
        
        handles.holtra(handles.trafos(handles.holtrarow),handles.holtrarow) = {''};
        
        handles.trafos(handles.holtrarow) = handles.trafos(handles.holtrarow) - 1;
        
    end
    
    if(handles.trafos(handles.holtrarow) == 1)
        
        set(hObject,'Enable','off');
        
    end
    
    set(handles.popupmenu6,'String',stri);
    
    disp_4_1(hObject,handles);
    
    guidata(hObject,handles);

end