%FreakLab - disenable.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Dieses Skript dient zum Aktiviern und Deaktivieren der Bedienfelder, d.h.
%alle slider, buttons, textfelder, popups und checkboxen werden aktiv- oder
%inaktiv geschalten. Nur wenn eine gltige Datei geladen ist und der
%Benutzer nicht gerade entscheiden muss, ob er eine transformierte Datei
%bernimmt oder verwirft, sollen die Bedienfelder aktiv sein.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

%com kann 'on' oder 'off' sein, je nachdem, ob aktiviert oder deaktiviert
%werden soll, num ist die Nummer des Bedienfeldes, das aktiviert oder
%deaktiviert werden soll
function disenable(hObject,handles,com,num)

    set(handles.pushbutton1,'Enable',com);
    set(handles.pushbutton7,'Enable',com);
    
    %Kommandos nur bei Deaktivierung
    if(com(2) == 'f')

        set(handles.pushbutton2,'Enable',com);
        set(handles.pushbutton3,'Enable',com);
        set(handles.text1,'BackgroundColor',[0.831373 0.815686 0.784314]);
        
        set(handles.output,'WindowButtonMotionFcn','');

    %Kommandos nur bei Aktivierung
    else

        set(handles.output,'WindowButtonMotionFcn','motion(gcbo,[],guidata(gcbo))');
        
        set(handles.pushbutton2,'Enable','off');
        set(handles.pushbutton3,'Enable','off');
        set(handles.text1,'BackgroundColor','Green');

        set(gcf,'CurrentAxes',handles.axes1);
        image(handles.image);
        axis off;

        set(gcf,'CurrentAxes',handles.axes2);
        image(handles.imtiny);
        axis off;

    end
    
    %Die bis hier abgearbeiteten Aktionen sind fr alle Bedienfeldnummern
    %gleich

    %Aktion fr Bedienfeld 1
    if(num == 1)

        set(handles.slider1,'Enable',com,'Value',0.5,'BackgroundColor',[.9 .9 .9]);
        set(handles.slider2,'Enable',com,'Value',0.5,'BackgroundColor',[.9 .9 .9]);
        set(handles.slider3,'Enable',com,'Value',0.5,'BackgroundColor',[.9 .9 .9]);
        set(handles.slider4,'Enable',com,'Value',0.5,'BackgroundColor',[.9 .9 .9]);

        set(handles.edit1,'Enable',com,'String',num2str(0,'%1.0f'));
        set(handles.edit2,'Enable',com,'String',num2str(0,'%1.2f'));
        set(handles.edit3,'Enable',com,'String',num2str(0,'%1.2f'));
        set(handles.edit4,'Enable',com,'String',num2str(0,'%1.2f'));

        set(handles.edit5,'Enable',com,'String',num2str(1,'%1.2f'));
        set(handles.edit6,'Enable',com,'String',num2str(0,'%1.2f'));
        set(handles.edit7,'Enable',com,'String',num2str(0,'%1.2f'));
        set(handles.edit8,'Enable',com,'String',num2str(1,'%1.2f'));

        set(handles.checkbox1,'Enable',com,'Value',0);
        set(handles.checkbox2,'Enable',com,'Value',0);
        set(handles.checkbox3,'Enable',com,'Value',0);

    %Aktion fr Bedienfeld 2
    elseif(num == 2)
        
        set(handles.slider5,'Enable',com,'Value',1/3,'BackgroundColor',[.9 .9 .9]);
        set(handles.edit13,'String',num2str(1,'%1.2f'),'Enable',com);
        set(handles.slider7,'Enable',com,'Value',1/3,'BackgroundColor',[.9 .9 .9]);
        set(handles.edit14,'String',num2str(1,'%1.2f'),'Enable',com);

        set(handles.slider6,'Enable',com,'Value',(1 + 10)/20,'BackgroundColor',[.9 .9 .9]);
        set(handles.edit9,'String',num2str(0,'%1.3f'),'Enable',com);
        set(handles.edit10,'String',num2str(0,'%1.3f'),'Enable',com);
        set(handles.edit11,'String',num2str(1,'%1.1f'),'Enable',com);
        set(handles.edit12,'String',num2str(1,'%1.2f'),'Enable',com);
        set(handles.checkbox4,'Enable',com,'Value',0);

        set(handles.popupmenu1,'Enable',com,'Value',1,'BackgroundColor',[.9 .9 .9]);
        set(get(handles.axes1,'Children'),'ButtonDownFcn','getcenter(gcbo,guidata(gcbo))');
        
        %Kommandos nur bei Deaktivierung
        if(com(2) == 'f')

            set(handles.pushbutton4,'Enable',com);
            set(handles.pushbutton5,'Enable',com);

        %Kommandos nur bei Aktivierung
        else

            if(handles.trafos < 9)

                set(handles.pushbutton4,'Enable',com);

            end

            if(handles.trafos > 1)

                set(handles.pushbutton5,'Enable',com);

            end
            
        end
       
    %Aktion fr Bedienfeld 3
    elseif(num == 3)
        
        set(handles.slider8,'Enable',com,'Value',1/3,'BackgroundColor',[.9 .9 .9]);
        set(handles.edit19,'String',num2str(1,'%1.2f'),'Enable',com);
        set(handles.slider9,'Enable',com,'Value',1/3,'BackgroundColor',[.9 .9 .9]);
        set(handles.edit20,'String',num2str(1,'%1.2f'),'Enable',com);

        set(handles.checkbox5,'Enable',com,'Value',0);

        set(handles.popupmenu2,'Enable',com,'Value',1,'BackgroundColor',[.9 .9 .9]);
        set(handles.edit18,'Enable',com,'BackgroundColor',[1 1 1]);
        set(handles.popupmenu3,'Enable',com,'Value',1,'BackgroundColor',[.9 .9 .9]);

        %Kommandos nur bei Deaktivierung
        if(com(2) == 'f')

            set(handles.edit18,'String','Formel hier eingeben');

            set(handles.pushbutton9,'Enable',com);
            set(handles.pushbutton10,'Enable',com);

        %Kommandos nur bei Aktivierung
        else

            set(handles.pushbutton9,'Enable','off');
            set(handles.pushbutton10,'Enable','off');

            if(handles.trafos < 9)

                set(handles.pushbutton9,'Enable',com);

            end

            if(handles.trafos > 1)

                set(handles.pushbutton10,'Enable',com);

            end

            stri2 = handles.holtra(1);
            stri2 = cell2struct(stri2,{'stri2'},1);
            stri2 = stri2.stri2;

            set(handles.edit18,'String',stri2);
            
        end

    %Aktion fr Bedienfeld 4
    elseif(num == 4)

        set(handles.popupmenu4,'Enable',com,'BackgroundColor',[.9 .9 .9]);
        set(handles.popupmenu5,'Enable',com,'BackgroundColor',[.9 .9 .9]);
        set(handles.popupmenu6,'Enable',com,'BackgroundColor',[.9 .9 .9]);
        set(handles.popupmenu7,'Enable',com,'BackgroundColor',[.9 .9 .9]);

        set(handles.edit21,'Enable',com,'BackgroundColor',[1 1 1]);

        %Kommandos nur bei Deaktivierung
        if(com(2) == 'f')

            set(handles.edit21,'String','Formel hier eingeben');

            set(handles.pushbutton11,'Enable',com);
            set(handles.pushbutton12,'Enable',com);

        %Kommandos nur bei Aktivierung
        else

            set(handles.pushbutton11,'Enable','off');
            set(handles.pushbutton12,'Enable','off');

            if(handles.trafos(handles.holtrarow) < 9)

                set(handles.pushbutton11,'Enable',com);

            end

            if(handles.trafos(handles.holtrarow) > 1)

                set(handles.pushbutton12,'Enable',com);

            end

            stri2 = handles.holtra(1,handles.holtrarow);
            stri2 = cell2struct(stri2,{'stri2'},1);
            stri2 = stri2.stri2;

            set(handles.edit21,'String',stri2);

        end

    end

end
    