%FreakLab - getcenter.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Diese Funktion greift auf die von motion.m erzeugte Variable 
%handles.cpoint zu, um bei Klick auf das Bild im Hauptanzeigefeld eine
%komplexe Zahl im Intervall [-1,1],[-i,i] auszuwhlen, welche in 
%FreakLab_opt2.m als Nullstelle des aktuellen Polynoms verwendet wird. Dazu
%muss fr die 'Children' von handles.axes1 diese Funktion als ButtonDownFcn
%gesetzt werden. Das geschieht in disenable.m.

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function getcenter(hObject,handles)

    %x- und y-Koordinaten als Re und Im der Nullstelle aufgefasst und auf 1
    %normiert
    rpos = handles.cpoint(1)/handles.imsize(2);
    ipos = handles.cpoint(2)/handles.imsize(1);
    
    rpos = 2*rpos - 1;
    ipos = 1 - 2*ipos;
    
    %Werte in die fr die Holomorphe Abbildung zustndige Datenmatrix
    %schreiben
    handles.holtra(handles.holtrac,2) = rpos;
    handles.holtra(handles.holtrac,3) = ipos;
    
    %Nullstelle im Eingabefeld 2 anzeigen
    set(handles.edit9,'String',num2str(rpos,'%1.3f'));
    set(handles.edit10,'String',num2str(ipos,'%1.3f'));
    
    %Preview mit dieser neuen Nullstelle erzeugen
    disp_2_1(hObject,handles);
    
end