%FreakLab - tformgen.m
%
%Erstellt von Matthias Hasewend im Rahmen der bung 'Applikationssoftware
%fr Fortgeschrittene' bei Ass. Prof. Winfried Kernbichler, Institut fr
%Theoretische Physik / Computational Physics an der TU Graz im WS 2010/11.
%
%Beschreibung:
%
%Diese Funktion generiert fr die Holomorphe und die Allgemeine komplexe
%Abbildung (Bedienfeld 2 und 3) den von imtransform geforderten Datensatz
%fr die Transformation. Dieser wird im Skript apply.m zur
%Transformation des groen Bildes und in disp_2_1.m sowie
%disp_3_1.m zur Erzeugung des Preview-Bildes verwendet.
%
%Dieses Skript bentigt wiederum die Funktionen trafo_1.m und
%trafo_2.m

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

%Ausgabe ist der von imtransform geforderte Datensatz
function tform = tformgen(handles,num)
    
    %Gesamttransformation besteht aus 3 Teilen
    %1.Teil: 2D-Vektoren in komplexe Zahlen verwandeln
    make_c = @(x) complex(x(:,1),x(:,2));

    %2.Teil: komplexe Zahlen in 2D-Vektoren verwandeln
    if(handles.per == 1)

        %einmal mit periodischer Fortsetzung (liegt in komplexer
        %Zahlenebene im Intervall [-1,1],[-i,i], daher Modulodivision mit
        %Periode 2)
        make_i = @(x) [mod(real(x)+1,2)-1,mod(imag(x)+1,2)-1];

    else

        %einmal ohne periodischer Fortsetzung
        make_i = @(x) [real(x),imag(x)];

    end

    %Gesamttransformation wird nun zusammengebastelt aus: Mache aus
    %2D-Bilddaten komplexe Zahl -> fhre komplexe Transformation aus ->
    %mache aus komplexer Zahl wieder 2D-Bilddaten
    if(num == 1)
        
        %fr Bedienfeld 2
        combo = @(x,unused) make_i(trafo_1(make_c(x),handles.holtra));
        
    elseif(num == 2)
        
        %fr Bedienfeld 3
        combo = @(x,unused) make_i(trafo_2(make_c(x),handles.holtra));
        
    end
    
    tform = maketform('custom',2,2,[],combo,[]);
    
end